export default async data => {
    data = data.toString();
    const crudeRfids = data.split('\n');

    const rfidsParsed = new Set();
    const rfidsParsedExtended = [];
    const RFID_PREFIX = 'AABB';
    for (let crudeRfid of crudeRfids) {
        if (crudeRfid && /{.*:{.*:.*}}/.test(crudeRfid)) {
            const jsonResult = JSON.parse(crudeRfid);
            let epcHex = jsonResult?.tagInventoryEvent?.epcHex;

            if (!epcHex) continue;
            if (epcHex.search(RFID_PREFIX) == -1) continue;

            epcHex = epcHex.replace(RFID_PREFIX, '');
            epcHex = epcHex.substring(0, 1) == 0 ? epcHex.substring(1) : epcHex;

            const rfidParsed = {
                code: parseInt(epcHex),
                created: jsonResult.timestamp,
                peakRssi: jsonResult.tagInventoryEvent.peakRssiCdbm,
                count: 1,
                antenna: jsonResult.tagInventoryEvent.antennaPort,
                transmitPowerCdbm: jsonResult.tagInventoryEvent.transmitPowerCdbm
            };

            rfidsParsedExtended.push(rfidParsed);
            rfidsParsed.add(rfidParsed.code);
        }
    }

    return {codes: rfidsParsed, extended: rfidsParsedExtended};
};

